#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>

#define LWORD unsigned long
#define WORD  unsigned short
#define BYTE  unsigned char
#define n  6144         // linux 12288

// GIF-parameter
unsigned char SuffixTable[4999], ByteBuf[n], BlockBuf[256];
short EncodeTable[4999], PrefixTable[4999];      // have in common_use
LWORD TempCode;
short Code, RunBits, ByteCount, ShiftBits;

//#define n   768
char head[36][80],h[36][80],a[60],g[60],c;
FILE  *fp;
float d[n][n];
short id[n][n];
unsigned char b[n*n];
int bit,zero,type;
int n1,n2,n11,n22;
int i8;
unsigned char tb_color[256][3];
unsigned char color_tb[14][3]={
            255,0,0,   0,255,0,   0,0,255,
            0,255,255, 255,0,255, 255,255,0,
            255,127,0, 127,255,0, 0,255,127, 0,127,255, 127,0,255, 255,0,127,
            85,85,85, 127,127,127
          };

main(ac,av)
int ac; char *av[];
{
  int   i,j,k,i1,j1,ip,q,kac;
  float x,y,z,zz,dsky=0.;
  int   shrink=1;
  int   revers=0;
  int   color=0;
  if(ac<2){
    printf("\n\t ****** change fits to any_size GIF ********\n");
    printf("\n\t                             jiang, 20120823\n");
    printf("\n\tUsage: g6 *.fit [-d skyadu_adjust] [-s n] [-t] [-c]\n");
    printf("\n\t\t-d skyadu_adjust      addjust backgroud before doing");
    printf("\n\t\t-s n  (n=0,1,...)     outpic shrink factor");
    printf("\n\t\t                      0: auto set ~512pixel");
    printf("\n\t\t-c                    outpic with color");
    printf("\n\t\t-t                    white,black grey_reverse\n");
    printf("\n\tex: g6 a0004.fit");
    printf("\n\t    g6 a0004.fit -d -100 -t -s 1");
    printf("\n\t    g6 a000*.fit -s 99");
    printf("\n\t    g6 abc.fit -t -c");
    printf("\n\t    g6 *.fit\n\n");
    exit(0);
  }
  for(i=1;i<ac;i++)if(av[i][0]=='-')break;
  kac=i;
  while(i<ac){
    if(av[i][0]!='-'){ printf("input command line error !!\n"), exit(0); }
    c=av[i++][1];
    if(c=='t')revers=1;
    if(c=='c')color=1;
    if(c=='d' || c=='s')if(i==ac){
                       printf("input command line error !!\n"), exit(0); }
    if(c=='d')sscanf(av[i++],"%f",&dsky);
    if(c=='s')sscanf(av[i++],"%d",&shrink);
  }
    for(i=0;i<=255;i++)for(j=0;j<3;j++)tb_color[i][j]=i;
    for(i=241;i<255;i++)for(j=0;j<3;j++)tb_color[i][j]=color_tb[254-i][j];
    if(color==0)for(i=241;i<255;i++)for(j=0;j<3;j++)tb_color[i][j]=255;
    if(revers){
      tb_color[0][0]=tb_color[0][1]=tb_color[0][2]=255;
      i1=255; if(color==0)i1=241;
      for(i=i1;i<=255;i++)for(j=0;j<3;j++)tb_color[i][j]=0;
    }
  for(ip=1;ip<kac;ip++){
    strcpy(a,av[ip]); strcpy(g,a);
    sprintf(&g[strlen(g)-3],"gif");
    printf("%3d: %s --> ",ip,a);
    fp=fopen(a,"rb");
    if(fp==0){ printf(" file not find !\n"); continue; }
    fread(head,36,80,fp);
    sscanf(&head[1][20],"%d",&bit);
    sscanf(&head[3][20],"%d",&n1);
    sscanf(&head[4][20],"%d",&n2);
    if(n1>n || n2 >n){
      printf(" only process %d*%d CCD, goto linux pls!\n",n,n); goto l10; }
    if(shrink==0){
      i8=1;
      if(n1>512  || n2 >512 )i8=2;
      if(n1>1024 || n2 >1024)i8=4;
      if(n1>2048 || n2 >2048)i8=8;
      if(n1>4096 || n2 >4096)i8=16;
    } else {
      i8=shrink;
      k=n1; if(k<n2)k=n2/16;
      if(i8>k){ printf("shrink factor is too small, I adjusted!!\n"); i8=k; }
    }
    k=indexpos(head,"END     ",36);
    while(k==36){ fread(h,36,80,fp); k=indexpos(h,"END     ",36); }
    if(bit==32){
      for(j=0;j<n2;j++)fread(d[j],n1,4,fp); swap4(d,n*n*4);
    }
    if(bit==16){
      for(j=0;j<n2;j++)fread(id[j],n1,2,fp); swap2(id,n*n*2);
      k=indexpos(head,"BZERO   ",36);
      sscanf(&head[k][12],"%d",&zero);
      for(j=0;j<n2;j++)for(i=0;i<n1;i++)d[j][i]=id[j][i]+zero;
    }
    if(bit==8)fread(b,n1,n2,fp);
    fclose(fp);
    if(bit==8){ n11=n1; n22=n2; goto l99; }
    type=0;                                                 // normal
    k=indexpos(head,"SUP_FLAT",36);  if(k!=36)type=1;       // flat
    k=indexpos(head,"SUP_BIAS",36);  if(k!=36)type=2;       // bias
    k=indexpos(head,"SKYADU  ",36);
    if(k==36)k=indexpos(head,"VOLT2   ",36);
    if(k!=36)sscanf(&head[k][12],"%f",&y); else {
      if(n1==4072){
        for(j=0;j<n2;j++)for(i=0;i<n1;i++)d[4071-i][j]=id[j][i]+zero;
        k=n1; n1=n2; n2=k;
        printf("(turn -90 deg.) ");
        sub1(0,0,0.);
        sub1(0,n1/2,0.);
        sub1(n2/2,0,0.);
        sub1(n2/2,n1/2,0.);
      } else {
        y=10000.;
        x=d[n2/4][n1/4*3];    if(y>x)y=x;
        x=d[n2/4][n1/4];      if(y>x)y=x;
        x=d[n2/4*3][n1/4*3];  if(y>x)y=x;
        x=d[n2/4*3][n1/4];    if(y>x)y=x;
      }
    }
    y-=dsky;
    if(a[0]=='e'){
        printf("filename 1st with e, defined as our BOK_RAW file\n");
        sub1(0,0,y);
        sub1(0,n1/2,y);
        sub1(n2/2,0,y);
        sub1(n2/2,n1/2,y);
    }
    if(type==1){ y=0.; printf("(sup_plat) "); }
    if(type==2){ y=0.; printf("(sup_bias) "); }

    zz=256+i8*i8;
    n11=n1/i8; n22=n2/i8;
    if(n11*i8!=n1)n11++; if(n22*i8!=n2)n22++;
    for(j=k=0;j<n2;j+=i8)for(i=0;i<n1;i+=i8){
      x=0.;  q=0;
      for(j1=j;j1<j+i8;j1++)for(i1=i;i1<i+i8;i1++)
        if(j1<n2 && i1<n1){ z=d[j1][i1]-y; if(z>zz)z=zz;  x+=z; q++; }
      if(type==0)x/=q;  if(type==2)x/=10.;
      x+=50.;  if(x<0.)x=0.; if(x>255.)x=255.;
      q=x; b[k++]=q;
    }
//      printf("k++:%d  n11*n22:%d n1.n2 %d %d\n",k,n11*n22,n11,n22);
l99:
    fp=fopen(g,"wb");  printf("%s   %d*%d\n",g,n11,n22);
    togif(b,n11,n22);
l10:
    fclose(fp);
  }
}

sub1(nj,ni,sky)
int nj,ni; float sky;
{
  float x,y;
  int i,j,k;
  short a[100*100];
  x=0.; k=0;
  for(j=nj+900;j<nj+1000;j++)for(i=ni+900;i<ni+1000;i++)a[k++]=d[j][i]/2.;
  white_black(a,1,k,&x,&y); x*=2.;
  for(j=nj;j<nj+n2/2;j++)for(i=ni;i<ni+n1/2;i++)d[j][i]-=(x-sky);
}

FillBlockBuf()
{
  TempCode |= (unsigned int)Code << ShiftBits;
  ShiftBits += RunBits;
  while(ShiftBits >= 8)  {
    BlockBuf[++ByteCount] = TempCode & 0x00FF;
    if(ByteCount == 255){
      BlockBuf[0] = (unsigned char)ByteCount;
      fwrite(BlockBuf, 1, ByteCount+1, fp);
      ByteCount = 0;
    }
    TempCode >>= 8;
    ShiftBits -= 8;
  }
}

togif(c256,m1,m2)
unsigned char *c256;
int m1,m2;
{
short Encode, MaxCodeSize, Width, Height, Dots, Rows;
short PrefixCode, SuffixCode, RandomIndex, Val;
short head1[7]={0x4947,0x3846,0x6137,0,0,0xf7,0};
short head2[5]={0,0,0,0,0x800};
LWORD jj;
  int i;

  head1[3]=head2[2]=Width=m1;
  head1[4]=head2[3]=Height=m2;
  fwrite(head1,1,13,fp);
  fwrite(tb_color,256,3,fp);
  fputc(0x2c,fp);
  fwrite(head2,2,5,fp);
  ByteCount = ShiftBits = TempCode = 0;

  Encode = 258;  RunBits = 9;  MaxCodeSize =512;
  for(i = 0; i < 4999; i++) EncodeTable[i] = 0;
  Code = 256;
  FillBlockBuf();
  for(Rows = 0; Rows < Height; Rows++)  {
    jj=(m2-1-Rows)*m1;
    for(i=0;i<m1;i++)ByteBuf[i]=c256[jj++];
    if(Rows == 0) { PrefixCode = ByteBuf[0];  Dots = 1; }
    else Dots = 0;
    while( Dots < Width)  {
      SuffixCode = ByteBuf[Dots++];
      RandomIndex = PrefixCode ^ (SuffixCode << 4);
      if(RandomIndex == 0)  Val = 1;
      else Val = 4999 - RandomIndex;
      while(1)  {
        if(EncodeTable[RandomIndex] == 0)  {
          Code = PrefixCode;
          FillBlockBuf();
          if(Encode == 4096)  {
            Code = 256;
            FillBlockBuf();
            Encode = 258;  RunBits = 9;  MaxCodeSize =512;
            for(i = 0; i < 4999; i++) EncodeTable[i] = 0;
          }
          else  {
            if(Encode == MaxCodeSize)  {
              MaxCodeSize <<= 1;
              RunBits++;
            }
            PrefixTable[RandomIndex] = PrefixCode;
            SuffixTable[RandomIndex] = (unsigned char)SuffixCode;
            EncodeTable[RandomIndex] = Encode++;
          }
          PrefixCode = SuffixCode;
          break;
        }
        if(PrefixTable[RandomIndex] == PrefixCode &&
           SuffixTable[RandomIndex] == SuffixCode)  {
          PrefixCode = EncodeTable[RandomIndex];
          break;
        }
        else  {
          RandomIndex -= Val;
          if(RandomIndex < 0)  RandomIndex += 4999;
        }
      }
    }
  }
  Code = PrefixCode;
  FillBlockBuf();
  Code = 257;
  FillBlockBuf();
  if(ShiftBits > 0 || ByteCount > 0)   {
    BlockBuf[++ByteCount] = TempCode & 0x00FF;
    BlockBuf[0] = (unsigned char)ByteCount;
    fwrite(BlockBuf, 1, ByteCount+1, fp);
    ByteCount = 0;
  }
  fputc(0, fp);  fputc(';', fp);
}

indexpos(head,f1,n0)
char head[][80],f1[8];
int n0;
{
  int i,j;
  for(i=0;i<n0;i++){
    for(j=0;j<8;j++) if(head[i][j]!=f1[j])goto l10;
    return i;
l10:
    continue;
  }
  return i;
}

swap2(char *a, int n0)
{
  register char *p;
  register int i;
  register char c;
  p = a;
  for(i=0;i<n0;i+=2){
    c = *p;
    *p++ = *(p+1);
    *p++ = c;
  }
}

swap4(char *a, int n0)       /*     long a[n] or float a[n]    */
{
  register char *p;
  register int i;
  register char c,d;
  p = a;
  for(i=0;i<n0;i+=4){
    c = *p;
    *p++ = *(p+3);
    d = *p;
    *p++ = *(p+1);
    *p++ = d;
    *p++ = c;
  }
}

white_black(map,n1,n2,peak,sigma)
short map[];
int n1,n2;
float *peak,*sigma;
{
  int *ihist;
  ihist=(int*)malloc(32767*4);
  white_black_1(map,n1,n2,peak,sigma,ihist);
  free(ihist);
}

white_black_1(map,n1,n2,xpeak,sigma,ihist)
short map[]; int n1,n2;
float *xpeak, *sigma;
long  ihist[];
{
  int i,ii;
  int imax=0;
  for(i=0;i<32767;i++)ihist[i]=0;
  for(i=0;i<n1*n2;i++){
    ii=map[i];
    ii+=101;
    if(ii<0 || ii >= 32767)continue;
    ihist[ii]++;
    if(ii>imax)imax=ii;
  }
  histat(ihist,xpeak,sigma,imax);
  *xpeak-=100.0;
}

histat(ihist,xpeak,fsigma,n0)
long ihist[];
float *xpeak,*fsigma;
int   n0;
{
  int ihtot=0, ihsum=0, iwid=0, maxh=0, mode=0;
  int i,ii,j,jj,k,m0,nn, isigm, nfilt, noff, ixpeak, ilow, ihih,ilim,icount;
  float xpar[101],buf[201];
  float xmean=0., xmed=0, sigmsq=0., xcount=0;
  float rttpi, conv, xx, temp, xp,fs,gs,cogd,cogn,cog,xnumb,sd;

  rttpi=2.506628275;
  for(i=1;i<=n0;i++){
    nn=n0+1-i;
    if(ihist[nn]!=0)break;
  }
  for(i=1;i<=nn;i++)ihtot+=ihist[i];
  for(i=1;i<=nn;i++){
    ihsum+=ihist[i];
    if(ihsum < 0.1*ihtot || ihsum > 0.9*ihtot)continue;
    if(ihist[i] <= maxh)continue;
    maxh=ihist[i];
    mode=i;
  }
  for(i=1;i<=nn;i++){
    temp=ihist[i];
    xcount+=temp;
    xmean+=temp*i;
    sigmsq+=temp*i*i;
  }
  for(i=1;i<=nn;i++){
    xmed+=ihist[i];
   if(xmed > 0.5*xcount){ xmed=i; break; }
  }
  xmean/=xcount;
  gs=xcount/(maxh*rttpi);
  if(gs > 0.1*nn)gs=0.1*nn;
  isigm=gs+0.5;
  if(isigm<3)isigm=3;
  if(isigm>50)isigm=50;
  nfilt=isigm*4+1;
  noff=(nfilt+1)/2;
  conv=0.5/(float)(isigm*isigm);
  for(i=1;i<=noff;i++){
    xx=i-noff;
    buf[i]=exp(-conv*xx*xx);
    buf[nfilt+1-i]=buf[i];
  }
  xp=mode;
  for(k=1;k<=2;k++){
    ixpeak=xp+0.5;
    if(ixpeak > nn)ixpeak=nn;
    if(ixpeak <1 )ixpeak=1;
    ilow=ixpeak-isigm;
    if(ilow <1 )ilow=1;
    ihih=ixpeak+isigm;
    if(ihih >nn)ihih=nn;
    m0=ihih-ilow+1;
    ii=1;  cogd=cogn=0.;
    for(i=ilow;i<=ihih;i++){
      cogd+=ihist[i];
      cogn+=ihist[i]*i;
      temp=xnumb=0.;
      for(j=1;j<=nfilt;j++){
        jj=j-noff;
        if(i+jj < 1 || i+jj > nn)continue;
        temp+=ihist[i+jj]*buf[j];
        xnumb+=buf[j];
      }
      temp = (xnumb > 0.) ? temp/=xnumb : 0. ;
      if(temp < 1.)temp=1.;
      xpar[ii++]=log((double)temp);
    }
    parbol(xpar,m0,&xp,&sd);
    xx=sd*sd-isigm*isigm;
    if(xx < 0.)xx=0.;
    fs=sqrt((double)xx);
    xp+=ilow-1;
    cog=(cogd > .5) ? cogn/cogd : xp;
    xx=xp-mode; if(xx <0.)xx=-xx;
    if(xx > gs)xp=cog;
  }
  mode--;
  xp=xp-1.0;
  xmean=xmean-1.0;
  xmed=xmed-1.0;
  if(xp > nn-gs)xp=xmed;
  if(xp < gs)xp=xmed;
  ixpeak=xp+1.5;
  icount=ihist[ixpeak];
  ilim=0.68*xcount+0.5;
  for(i=1;i<=nn;i++){
    ii=ixpeak+i;
    if(ii <= nn){
      iwid++;
      icount+=ihist[ii];
      if(icount > ilim)break;
    }
    ii=ixpeak-i;
    if(ii >= 1){
      iwid++;
      icount+=ihist[ii];
      if(icount > ilim)break;
    }
  }
  gs=0.5*iwid;
  if(gs<fs)fs=gs;
  if(fs<1.)fs=1.;
  *xpeak=xp;
  *fsigma=fs;
}

parbol(a,n0,xpeak,sd)
float a[],*xpeak,*sd; int n0;
{
  float aa,fi,fi2;
  float cmatx[25][25],bvect[25];   /* same as fortran , 1--24 */
  float suma=0.,sumay=0.,sumayy=0.,sumy1=0.,sumy2=0.,sumy3=0.,sumy4=0.;
  int i,j;

  for(i=1;i<25;i++){
    bvect[i]=0.;
    for(j=1;j<25;j++)cmatx[i][j]=0.;
  }
  for(i=1;i<=n0;i++){
    aa=a[i]; fi=i; fi2=i*i;
    suma+=aa;  sumay+=aa*fi; sumayy+=aa*fi2;
    sumy1+=fi; sumy2+=fi2;   sumy3+=fi*fi2;   sumy4+=fi2*fi2;
  }
  cmatx[1][1]=n0;     cmatx[1][2]=sumy1; cmatx[1][3]=sumy2;
  cmatx[2][1]=sumy1; cmatx[2][2]=sumy2; cmatx[2][3]=sumy3;
  cmatx[3][1]=sumy2; cmatx[3][2]=sumy3; cmatx[3][3]=sumy4;
  bvect[1]=suma;     bvect[2]=sumay;    bvect[3]=sumayy;
  solve(cmatx,bvect,3);
  if(bvect[3] == 0) *xpeak= *sd=0.;
  else {
    aa=bvect[3]*2.;
    *xpeak=-bvect[2]/aa;
    if(aa < 0.)aa=-aa;
    *sd=sqrt((double)1.0/aa);
  }
}

solve(a,b,m0)
float a[25][25],b[25]; int m0;
{
  int i,j,k,l;
  float big,temp;

  for(i=1;i<m0;i++){
    big=0.;
    for(k=i;k<=m0;k++){
      temp=a[k][i];
      if(temp < 0.)temp=-temp;
      if(temp > big){ big=temp; l=k; }
    }
    if(big == 0.){
      for(k=1;i<=m0;k++)b[k]=0;
      printf(" Zero determinant from SOLVE\n");
      return;
    }
    if(i != l){
      for(j=1;j<=m0;j++){ temp=a[i][j]; a[i][j]=a[l][j]; a[l][j]=temp;}
      temp=b[i]; b[i]=b[l]; b[l]=temp;
    }
    big=a[i][i];
    for(j=i+1;j<=m0;j++){
      temp=a[j][i]/big;
      b[j]-=temp*b[i];
      for(k=i;k<=m0;k++)a[j][k]-=temp*a[i][k];
    }
  }
  for(i=1;i<=m0;i++){
    l=m0+1-i;
    if(a[l][l]==0.){ b[l]=0.; continue; }
    temp=b[l];
    if(l != m0)for(j=2;j<=i;j++){ k=m0+2-j; temp-=a[l][k]*b[k]; }
    b[l]=temp/a[l][l];
  }
}
